FUNCTION_BLOCK GeneratoreOndaQuadra
  VAR_INPUT
    Input : BOOL;
  END_VAR
  VAR_OUTPUT
    Output : BOOL;
  END_VAR
  VAR
    R_TRIG1 : R_TRIG;
    R_TRIG2 : R_TRIG;
    R_TRIG3 : R_TRIG;
  END_VAR

  INITIAL_STEP Quiete:
    COMPUTE_FUNCTION_BLOCKS(S);
  END_STEP

  ACTION COMPUTE_FUNCTION_BLOCKS:
    R_TRIG1(CLK := Input);
    R_TRIG2(CLK := Input);
    R_TRIG3(CLK := Input);
  END_ACTION

  TRANSITION FROM Quiete TO Onda_On
    := R_TRIG1.Q;
  END_TRANSITION

  STEP Onda_On:
    Output(N);
  END_STEP

  TRANSITION FROM Onda_On TO Quiete
    := R_TRIG2.Q;
  END_TRANSITION

  TRANSITION FROM Onda_On TO Onda_Off
    := (Onda_On.T>=T#4s) AND (NOT(Input));
  END_TRANSITION

  STEP Onda_Off:
  END_STEP

  TRANSITION FROM Onda_Off TO Quiete
    := R_TRIG3.Q;
  END_TRANSITION

  TRANSITION FROM Onda_Off TO Onda_On
    := (Onda_Off.T>=T#6s) AND (NOT(Input));
  END_TRANSITION

END_FUNCTION_BLOCK

PROGRAM Main
  VAR
    IN : BOOL;
    OUT : BOOL;
    OndaQuadra : GeneratoreOndaQuadra;
  END_VAR

  OndaQuadra(Input:=IN);
  OUT:=OndaQuadra.Output;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK CicloDiScansione(INTERVAL := T#100ms,PRIORITY := 0);
    PROGRAM InstanzaMain WITH CicloDiScansione : Main;
  END_RESOURCE
END_CONFIGURATION
